# -*- encoding: utf-8 -*-
# refark-0.09
# author: kouett
# license: WTFPL
# code: messy
import sys
import os
import re
import urllib

## TODO: 
## DONE:
## - faire un script dw.sh pour télécharger manuellement (dans stornam)
##   wget -prl1 http://blah.com/page.php?p=a -O 00/1/0/page.php?p=a -o 00/1/0/.log
## - wget url exclude (youtube)
## - makeskel devrait appeller htmlindex
## - build descriptions
## - multiple urls in ref
## - dir hierarchy
## - faire un index des références en début d'index:
##   partie 00
##   <p>_1_ _2_ _3_ _4_</p> <-ce sont des liens, chaque ref a un id
## - possibilité de désactiver l'archivage
## IDEAS:



def file2refs(datafile):
       """ construction des références depuis un fichier """
       url_re="https?://\S+"
       ref_re="^[0-9]+ :"
       refextract_re="^[0-9]+"
       lines=datafile.readlines()
       refs=[]
       for i in range(0,len(lines)): # 0 to len(lines)-1
              if re.search(ref_re,lines[i]) != None: # reg matches
                     tmp=""
                     j=i
                     while True: # do-while
                            tmp=tmp + lines[j]
                            if j<len(lines)-1:
                                   j+=1
                                   if re.search(ref_re,lines[j]) == None:
                                          continue # reg doesn't match, we extend the current line
                                   else:
                                          break
                            else:
                                   break
                     # un peu de traitement (évite les urls collées entre elles)
                     # archive.org utilise des url "collées" en fait, et il n'y avait que ça
                     # tmp=re.sub("(?=\S)http://"," http://",tmp)
                     # tmp=re.sub("(?=\S)https://"," https://",tmp)
                     tmp=tmp.replace('\n','')
                     # on construit les refs
                     refid=re.findall(refextract_re,tmp)[0]
                     text=re.sub(ref_re,'',tmp)
                     urls=re.findall(url_re,tmp)
                     suburls=[]
                     for subid in range(len(urls)):
                            suburls.append({"subid":str(subid),"url":urls[subid]})
                     refs.append({"id":refid,"text":text,"urls":suburls})
       return refs

def files2refs(files):
       """ construction des références, avec tous les fichiers donnés en argument. files est une liste de fichiers """
       multirefs=[]
       for i in range(len(files)):
              src_fd=file(files[i],'r')
              partnam=delext(basename(files[i]))
              frefs=file2refs(src_fd) # file refs
              # multirefs.append({"part":partnam,"refs":ref_fr_file})
              for fref in frefs: # reconstruction avec un attribut en plus
                     multirefs.append({"part":partnam,"id":fref["id"],"text":fref["text"],"urls":fref["urls"]})
       return multirefs


def makeskel(fromrefs,stornam,arc=False,arcexcludes=[]):
       """ crée la structure de stockage sur disque pour les références """
       # TODO: check that files are readable
       # everything is ok, we can go !
       # data structure:
       # stornam/index.html
       # stornam/basename/id/subid
       # stornam/basename/id/subid/.log
       # stornam/basename/id/subid/.url
       # stornam/basename/id/subid/{bordel html}
       # build base dir structure
       if stornam not in os.listdir("."):
              os.mkdir(stornam)
       # nous sommes maintenant dans le répertoire de travail (évitons d'écraser les données autour de nous)
       # prêts à créer la structure
       os.chdir(stornam)
       for ref in fromrefs:
              part=ref["part"]
              text=ref["text"]
              urls=ref["urls"]
              refid=ref["id"]
              # que fait-on si il n'y a pas d'url ?
              for url in urls: # maintenant on a ce qui caratérise chaque url: partie, id référence, sous-id
                     subid=url["subid"]
                     url=url["url"]
                     refpath=(part,refid,subid)
                     newpath="."
                     for d in refpath:
                            oldpath=newpath
                            newpath+=os.sep+d
                            if d not in os.listdir(oldpath):
                                   os.makedirs(newpath)
                     # tous les répertoires sont maintenant créés
                     url_fd=file(newpath+os.sep+".url",'w')
                     url_fd.write(url)
                     url_fd.close()
       # now we store indexes etc
       index_fd=file("index.html","w")
       if arc:
              dwsh_fd=file("dw.sh","w")
              dwsh_fd.write(getdwsh(fromrefs,excludes))
              index_fd.write(htmlindex(fromrefs,arc=True,excludes=excludes))
              dwsh_fd.close()
       else:
              index_fd.write(htmlindex(fromrefs,arc=False))
       index_fd.close()
       os.chdir("..") # et on n'oublie pas de se remettre dans le répertoire courant


def isexcluded(url,excludes):
       """ vérifie que url n'est pas dans la liste d'exclusion (liste d'expressions régulières) """
       for exclude in excludes:
              if re.match(exclude,url):
                     return True
       return False
# quick
def basename(name):
       return re.sub(".+"+os.sep+"(?=.+)","",name)
# remove file extension
def delext(name):
       return re.sub("(?=.+)\..+","",name)
def stripurl(url):
       # si il n'y a pas de '/' final (http://example.com)
       if url.count('/') != 2:
              return re.sub("https?://(\S+/)+","",url)
       else:
              return ''

def refbyparts(fromrefs):
       """ Retourne un objet dict avec toutes les références dans leur parties respectives: {"part1":refs_part1,"part2":refs_part2}. """
       curr_part=""
       partnames=[]
       for ref in fromrefs:
              if curr_part != ref["part"]:
                     curr_part=ref["part"]
                     partnames.append(curr_part)
       # on a désormais tout les noms des parties
       refbyparts=dict.fromkeys(partnames,[])
       for ref in fromrefs:
              for partname in partnames:
                     if ref["part"] == partname:
                            refbyparts[partname]=refbyparts[partname]+[ref]
       return (refbyparts,partnames)
       
# dw.sh est placé dans stornam/dw.sh
# WARING: ne pas oublir de cd !
def getdwsh(fromrefs,excludes=[]):
       """ Construit le script de téléchargement dw.sh et retourne son contenu (la fonction appellante se charge de l'écrire). """
       s="#!/bin/bash\n"
       s+="# ce script vour permet de télécharger manuellement l'ensemble des urls dans les références\n" # script contents
       s+="function err {\n"+\
       "errs[1]='generic error';\n"+\
       "errs[3]='I/O error';\n"+\
       "errs[4]='network failure';\n"+\
       "errs[5]='ssl verification failure';\n"+\
       "errs[7]='protocol errors';\n"+\
       "errs[8]='server issued an error response';\n"+\
       "local errcode=\"$1\";\n"+\
       "local wdir=\"$2\";\n"+\
       "local tgt=\"$3\";\n"+\
       "echo ERR ${errs[$errcode]} 'ref' $wdir on url $tgt>&2;\n"+\
       "}\n"+\
       "function wgetc {\n"+\
       "declare -a nonerrors=('3[0-9][0-9]' '200')\n"+\
       "reallyerror=1; returncode=0;\n"+\
       "(sleep 1; wget -U 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36' -t 5 -T 30 --random-wait -e robots=off -N --backup-converted --convert-links -nH -nd \"$1\" -o .log && touch .ok) || returncode=$?\n"+\
       "if [ ! $returncode = 0 ]; then\n"+\
       "for nonerror in ${nonerrors[*]}; do (head .log | grep \".*HTTP.*$nonerror\") && (touch .ok; reallyerror=0;) done\n"+\
       "[ $reallyerror = 1 ] && return $returncode; # I don't know what more I could do, call err handler\n"+\
       "fi\n}\n"
       for ref in fromrefs:
              urls=ref["urls"]
              for url in urls:
                     tgt=url["url"]
                     if not isexcluded(tgt,excludes):
                            wdir=ref["part"]+"/"+ref["id"]+"/"+url["subid"]
                            logpath=wdir+"/.log"
                            # tgtpath=wdir+"/"+stripurl(tgt)
                            s+="cd "+wdir+"; [ ! -e '.ok' ] && (wgetc \'"+tgt+"\' -o .log || err $? \""+wdir+"\" '"+tgt+"'); cd ../../..\n"
       return s

def htmlindex(fromrefs,arc,excludes=[]):
       """ Construit l'index au format html (la fonction appellante doit se charger de l'enregistrer). """
       # on construit un dict par partie (plus aisé de générer le html comme ça)
       # htmlindex a besoin que les refs de même partie soient groupées
       hdr="<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"+ \
       "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n"+ \
       "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n"+ \
       "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">\n"+ \
       "<head>\n"+ \
       "<title>références</title>\n"+ \
       "<meta  http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />\n"+ \
       "</head>\n<body>"
       ftr="</body>\n</html>"
       pagetxt=""
       refltxt=""
       toctxt=""
       refbypart=refbyparts(fromrefs)
       partnames=refbypart[1] # on récupère les deux résultat ainsi
       refbypart=refbypart[0]
       for partname in partnames: # refbypart est un dict
              partrefs=refbypart[partname]
              refltxt+="<h2 id=\""+partname+"\">"+partname+"</h2>\n"
              toctxt+="<h2>références pour la partie "+partname+"</h2>\n<p>"
              litxt="<ul>\n"
              for ref in partrefs:
                     toctxt+="<a href=\"#"+ref["part"]+"-"+ref["id"]+"\">"+ref["id"]+"</a> \n"
                     newli=ref["id"]+" : "+ref["text"]
                     start=0
                     for url in ref["urls"]:
                            urlstr=url["url"]
                            refpos=newli[start:].find(urlstr)+len(urlstr)+start # où doit-on insérer les liens ?
                            insert=" <a href=\""+urlstr+"\">[direct]</a>"
                            if arc and not isexcluded(urlstr,excludes):
                                   # Grosse bidouille:
                                   # je n'ai toujours pas trouvé de solution satisfaisante, entre
                                   # les trucs url-encodés (de base ou non) et d'autres solutions.
                                   # soit vous utilisez le dirlisting côté serveur et donc la ligne ci-dessous
                                   # arcdir=ref["part"]+"/"+ref["id"]+"/"+url["subid"]+"/"
                                   # soit vous ne l'utilisez pas et utilisez des urls quotées (ligne ci-dessous)
                                   arcdir=ref["part"]+"/"+ref["id"]+"/"+url["subid"]+"/"+urllib.quote(stripurl(urlstr)).replace("%23","#") # tellement crade
                                   insert+="<a href=\""+arcdir+"\">[arc]</a>"
                            newli=newli[0:refpos]+insert+newli[refpos:]
                            start=refpos+len(insert)
                     litxt+="<li id=\""+ref["part"]+"-"+ref["id"]+"\">"+newli+"</li>\n"
              refltxt+=litxt+"</ul>\n"
              toctxt+="</p>\n"
       pagetxt=hdr+toctxt+refltxt+ftr
       return pagetxt
                     

#### MAIN ####
excludes=[".+youtube.com.+",
          ".+archive.org.+",
          ".+wikipedia.org.+"]
stornam="refstor"
if len(sys.argv)<=1:
       print("at least one source datafile must be given")
       exit
# nous construisons à présent les références à partir des sources
allrefs=files2refs(sys.argv[1:])
# puis nous les stockons sur disque
makeskel(allrefs,stornam,arc=True,arcexcludes=excludes)

